#version 140

in vec4 varColor;
in vec2 varTexCoord;
in vec2 varEnvCoord;
in float varFog;

out vec4 outColor;

// textures
uniform bool isTextured;
uniform sampler2D diffuseTexture;
uniform sampler2D envTexture;

// alpha test
uniform bool alphaTest;
uniform float alphaRef;

// fog vars
uniform bool inFog;
uniform vec3 fogColor;

// env vars
uniform bool setEnv;
uniform vec3 envColor;

void main(void)
{
  //if (isTextured) {
  vec4 diffuse = texture(diffuseTexture, varTexCoord);
  if (alphaTest) {
    if (diffuse.a < alphaRef) {
      discard;
    }
  }

  outColor = varColor * diffuse;
  //} else {
  //  outColor = varColor;
  //}

  if (setEnv) {
    vec4 specular = texture(envTexture, varEnvCoord);
    outColor.rgb += envColor * specular.rgb;
  }

  if (inFog) {
    outColor.rgb = mix(fogColor, outColor.rgb, varFog);
  }
}
